//+------------------------------------------------------------------+
//|                                         alb - moving average.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int    swingCount       = 5;
extern int    mode             = MODE_EMA;
extern int    price            = PRICE_CLOSE;
extern double speed            = 2.0;
extern double smooth           = 5;
extern int    swingCount2      = 5;
extern int    mode2            = MODE_EMA;
extern int    price2           = PRICE_CLOSE;
extern double speed2           = 1.0;
extern double smooth2          = 5;
extern bool   alertsOn         = false; // Turn alert on or off
extern bool   alertsOnCurrent  = true;  // Alerts on current (still opened) bar
extern bool   alertsMessage    = true;  // Alerts should show pop-up message
extern bool   alertsPushNotif  = false; // Alerts should send push notification
extern bool   alertsSound      = false; // Alerts should play a sound
extern bool   alertsEmail      = false; // Alerts should send email

//
//
//
//
//

double swingBuffer[];
double maBuffer[];
double maBuffer2[];
double maBufferhu[];
double maBufferhd[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,maBufferhu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,maBufferhd); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,maBuffer);
   SetIndexBuffer(3,maBuffer2);
   SetIndexBuffer(4,swingBuffer);
   SetIndexBuffer(5,slope);
      speed  = MathMax(speed ,0.000001);
      speed2 = MathMax(speed2,0.000001);
   return(0);
}
int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
   
      //
      //
      //
      //
      //
      
      int k = i;
      int n = 0;
         for (; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
               double albPeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
      maBuffer[i] = iSsm(iMA(NULL,0,albPeriod,0,mode,price,i),smooth,i,0);
      k = i;
      n = 0;
         for (; (k<Bars) && (n<swingCount2); k++) if(swingBuffer[k]!=0) n++;
               double albPeriod2 = MathMax(MathRound((k-i)/swingCount2/speed2),1);
      maBuffer2[i] = iSsm(iMA(NULL,0,albPeriod2,0,mode2,price2,i),smooth2,i,1);
      maBufferhu[i] = EMPTY_VALUE;
      maBufferhd[i] = EMPTY_VALUE;
      slope[i]      = slope[i+1];
         if (maBuffer[i]>maBuffer2[i]) slope[i] =  1;
         if (maBuffer[i]<maBuffer2[i]) slope[i] = -1;
         if (slope[i] ==  1) maBufferhu[i] = 1;
         if (slope[i] == -1) maBufferhd[i] = 1;
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar+1]==-1) doAlert(whichBar,"slope up");
         if (slope[whichBar+1]== 1) doAlert(whichBar,"slope down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" alb ma changed "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," alb ma "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," alb ma "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288
double workSsm[][4];
#define _tprice 0
#define _ssm    1

double workSsmCoeffs[][8];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3

//
//
//
//
//

double iSsm(double tprice, double period, int i, int instanceNo=0)
{
   if (period<=1) return(tprice); i = Bars-i-1;
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      int s = instanceNo*2;   
          workSsm[i][s+_tprice] = tprice;
          workSsm[i][s+_ssm]    = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                                  workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                                + 
                                  workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm]; 
   return(workSsm[i][s+_ssm]);
}